/* Copyright (C) Xi'an Sietium Electronics Co.Ltd */
/*
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
#ifndef __GB02_FPGA_V2VDMA_H
#define __GB02_FPGA_V2VDMA_H

#define	GB02MAC296
#define	GB02MAC297
#ifndef	GB02MAC296
#define	GB02MAC298	(2 * 1024)
#define	GB02MAC299	0x50000//0x500000
#define	GB02MAC300	0x10000//0x100000
#define	GB02MAC301	0x100000//0x100000
#define		GB02MAC302  0xc0000000
#define		GB02MAC303	0x1000000

#else

#define	GB02MAC299	0x800//0x500000
#define	GB02MAC304	GB02MAC1043//0x80400000
#define	GB02MAC305	GB02MAC1047//0x81000000
#define	GB02MAC307	0x800000000
#define	GB02MAC308	0x80000000
#endif

#define GB02MAC312	(6)
#define GB02MAC314 (1)
#define GB02MAC315 (2) /* DWAXIDMAC_TRANS_WIDTH_256 */
#define GB02MAC317 (255) /* DWAXIDMAC_ARWLEN_256 */
#define GB02MAC319 (0) /* channel 0 */
#define GB02MAC321 (1)

#define GB02MAC324				(0x1000) /* 4KB */
#define GB02MAC326			(0x400000) /* 4MB */
#define GB02MAC24				(0x4000) /* 16KB */
#define GB02MAC329			(0x100000)
#define GB02MAC330			(0x500000)

#define GB02MAC331 (0x40)

#define GB02MAC332 (0xc0000000) /* view at V2VDMA side */

/* LLI == Linked List Item */
struct __packed GB02STR36 {
	__le64	sar;
	__le64	dar;
	__le32	block_ts_lo;
	__le32	block_ts_hi;
	__le64	llp;
	__le32	ctl_lo;
	__le32	ctl_hi;
	__le32	sstat;
	__le32	dstat;
	__le32	status_lo;
	__le32	ststus_hi;
	__le32	reserved_lo;
	__le32	reserved_hi;
};

struct GB02STR39 {
	struct GB02STR36	lli;
	struct GB02STR40	*chan;
	struct list_head	xfer_list;
	u64	phys;
};

struct GB02STR40 {
	void __iomem *chan_regs;
	u8 id;
	struct GB02STR42 *chip;
	atomic_t descs_allocated;
	struct GB02STR39 *first_desc;
};

struct GB02STR42 {
	void __iomem *regs;
	struct GB02STR40 chan[GB02MAC312];
	int chan_count;
	unsigned __iomem *dma_src_addr;
	unsigned __iomem *dma_dst_addr;

	u64	dma_src_paddr[GB02MAC312];
	u64	dma_dst_paddr;
	int	tsfd_num;
	dma_addr_t dma_src_handle;
	dma_addr_t dma_dst_handle;

	u64 pos[GB02MAC312];
};

static inline u32 GB02FUNC172(struct GB02STR42 *chip, u32 offset)
{
	u32 val = 0;

	val = ioread32(chip->regs + offset);
	return val;
}

static inline void GB02FUNC174(struct GB02STR42 *chip,
	u32 offset, u32 val)
{
	iowrite32(val, chip->regs + offset);
}

static inline u32 GB02FUNC13(struct GB02STR40 *chan, u32 offset)
{
	u32 val = 0;

	val = ioread32(chan->chan_regs + offset);
	return val;
}

static inline void GB02FUNC15(struct GB02STR40 *chan,
	u32 offset, u32 val)
{
	iowrite32(val, chan->chan_regs + offset);
}

static inline void GB02FUNC17(struct GB02STR40 *chan,
	u32 offset, u64 val)
{
	iowrite32(lower_32_bits(val), chan->chan_regs + offset);
	iowrite32(upper_32_bits(val), chan->chan_regs + offset + 4);
}

void GB02FUNC84(struct GB02STR42 *chip);
void GB02FUNC93(struct GB02STR42 *chip);
u32 GB02FUNC109(struct GB02STR40 *chan);
void GB02FUNC107(struct GB02STR40 *chan, u32 irq_mask);
void GB02FUNC150(struct GB02STR40 *chan, u32 status);
void GB02FUNC152(struct GB02STR40 *chan);
void GB02FUNC97(struct GB02STR42 *chip);

#define GB02MAC33		0x100
#define GB02MAC34		0x100

/* Common registers offset */
#define GB02MAC337			0x000 /* R DMAC ID */
#define GB02MAC339		0x008 /* R DMAC Component Version */
#define GB02MAC341		0x010 /* R/W DMAC Configuration */
#define GB02MAC343		0x018 /* R/W DMAC Channel Enable */
#define GB02MAC345		0x018 /* R/W DMAC Channel Enable 00-31 */
#define GB02MAC347		0x01C /* R/W DMAC Channel Enable 32-63 */
#define GB02MAC349		0x030 /* R DMAC Interrupt Status */
#define GB02MAC351	0x038 /* W DMAC Interrupt Clear */
#define GB02MAC353 0x040 /* R DMAC Interrupt Status Enable */
#define GB02MAC356 0x048 /* R/W DMAC Interrupt Signal Enable */
#define GB02MAC359	0x050 /* R DMAC Interrupt Status */
#define GB02MAC362		0x058 /* R DMAC Reset Register1 */

/* DMA channel registers offset */
#define GB02MAC366			0x000 /* R/W Chan Source Address */
#define GB02MAC369			0x008 /* R/W Chan Destination Address */
#define GB02MAC372		0x010 /* R/W Chan Block Transfer Size */
#define GB02MAC375			0x018 /* R/W Chan Control */
#define GB02MAC378		0x018 /* R/W Chan Control 00-31 */
#define GB02MAC379		0x01C /* R/W Chan Control 32-63 */
#define GB02MAC381			0x020 /* R/W Chan Configuration */
#define GB02MAC383		0x020 /* R/W Chan Configuration 00-31 */
#define GB02MAC384		0x024 /* R/W Chan Configuration 32-63 */
#define GB02MAC386			0x028 /* R/W Chan Linked List Pointer */
#define GB02MAC388		0x030 /* R Chan Status */
#define GB02MAC390		0x038 /* R/W Chan SW Handshake Source */
#define GB02MAC392		0x040 /* R/W Chan SW Handshake Destination */
#define GB02MAC394	0x048 /* W Chan Block Transfer Resume Req */
#define GB02MAC396		0x050 /* R/W Chan AXI ID */
#define GB02MAC399		0x058 /* R/W Chan AXI QOS */
#define GB02MAC401		0x060 /* R Chan Source Status */
#define GB02MAC404		0x068 /* R Chan Destination Status */
#define GB02MAC407		0x070 /* R/W Chan Source Status Fetch Addr */
#define GB02MAC409	0x078 /* R/W Chan Destination Status Fetch Addr */
#define GB02MAC411	0x080 /* R/W Chan Interrupt Status Enable */
#define GB02MAC413		0x088 /* R/W Chan Interrupt Status */
#define GB02MAC414	0x090 /* R/W Chan Interrupt Signal Enable */
#define GB02MAC416		0x098 /* W Chan Interrupt Clear */


/* GB02MAC341 */
#define GB02MAC419			0
#define GB02MAC421			BIT(GB02MAC419)

#define GB02MAC424			1
#define GB02MAC426			BIT(GB02MAC424)

#define GB02MAC429		0
#define GB02MAC431		8

#define GB02MAC433		16
#define GB02MAC435		24

/* GB02MAC379 */
#define GB02MAC439		BIT(6)
#define GB02MAC442		7
#define GB02MAC444		BIT(15)
#define GB02MAC446		16

enum {
	DWAXIDMAC_ARWLEN_1		= 0,
	DWAXIDMAC_ARWLEN_2		= 1,
	DWAXIDMAC_ARWLEN_4		= 3,
	DWAXIDMAC_ARWLEN_8		= 7,
	DWAXIDMAC_ARWLEN_16		= 15,
	DWAXIDMAC_ARWLEN_32		= 31,
	DWAXIDMAC_ARWLEN_64		= 63,
	DWAXIDMAC_ARWLEN_128		= 127,
	DWAXIDMAC_ARWLEN_256		= 255,
	DWAXIDMAC_ARWLEN_MIN		= DWAXIDMAC_ARWLEN_1,
	DWAXIDMAC_ARWLEN_MAX		= DWAXIDMAC_ARWLEN_256
};

#define GB02MAC452		BIT(30)
#define GB02MAC453		BIT(31)

/* GB02MAC378 */
#define GB02MAC456		BIT(30)

#define GB02MAC457		18
#define GB02MAC458		14
#define	GB02MAC459		63

enum {
	DWAXIDMAC_BURST_TRANS_LEN_1	= 0,
	DWAXIDMAC_BURST_TRANS_LEN_4,
	DWAXIDMAC_BURST_TRANS_LEN_8,
	DWAXIDMAC_BURST_TRANS_LEN_16,
	DWAXIDMAC_BURST_TRANS_LEN_32,
	DWAXIDMAC_BURST_TRANS_LEN_64,
	DWAXIDMAC_BURST_TRANS_LEN_128,
	DWAXIDMAC_BURST_TRANS_LEN_256,
	DWAXIDMAC_BURST_TRANS_LEN_512,
	DWAXIDMAC_BURST_TRANS_LEN_1024
};

enum {
	DWAXIDMAC_CH_CTL_SHADOW_LL_INVALID	= 0,
	DWAXIDMAC_CH_CTL_SHADOW_LL_VALID
};

#define GB02MAC469		11
#define GB02MAC470		8

#define GB02MAC471		6
#define GB02MAC472		4
enum {
	DWAXIDMAC_CH_CTL_L_INC		= 0,
	DWAXIDMAC_CH_CTL_L_NOINC
};

#define GB02MAC473		BIT(2)
#define GB02MAC474		BIT(0)

/* GB02MAC384 */
#define GB02MAC475		17
#define GB02MAC476		4
#define GB02MAC477		3
enum {
	DWAXIDMAC_HS_SEL_HW		= 0,
	DWAXIDMAC_HS_SEL_SW
};

#define GB02MAC478		0
enum {
	DWAXIDMAC_TT_FC_MEM_TO_MEM_DMAC	= 0,
	DWAXIDMAC_TT_FC_MEM_TO_PER_DMAC,
	DWAXIDMAC_TT_FC_PER_TO_MEM_DMAC,
	DWAXIDMAC_TT_FC_PER_TO_PER_DMAC,
	DWAXIDMAC_TT_FC_PER_TO_MEM_SRC,
	DWAXIDMAC_TT_FC_PER_TO_PER_SRC,
	DWAXIDMAC_TT_FC_MEM_TO_PER_DST,
	DWAXIDMAC_TT_FC_PER_TO_PER_DST
};

/* GB02MAC383 */
#define GB02MAC479	2
#define GB02MAC480	0
enum {
	DWAXIDMAC_MBLK_TYPE_CONTIGUOUS	= 0,
	DWAXIDMAC_MBLK_TYPE_RELOAD,
	DWAXIDMAC_MBLK_TYPE_SHADOW_REG,
	DWAXIDMAC_MBLK_TYPE_LL
};

/**
 * DW AXI DMA channel interrupts
 *
 * @DWAXIDMAC_IRQ_NONE: Bitmask of no one interrupt
 * @DWAXIDMAC_IRQ_BLOCK_TRF: Block transfer complete
 * @DWAXIDMAC_IRQ_DMA_TRF: Dma transfer complete
 * @DWAXIDMAC_IRQ_SRC_TRAN: Source transaction complete
 * @DWAXIDMAC_IRQ_DST_TRAN: Destination transaction complete
 * @DWAXIDMAC_IRQ_SRC_DEC_ERR: Source decode error
 * @DWAXIDMAC_IRQ_DST_DEC_ERR: Destination decode error
 * @DWAXIDMAC_IRQ_SRC_SLV_ERR: Source slave error
 * @DWAXIDMAC_IRQ_DST_SLV_ERR: Destination slave error
 * @DWAXIDMAC_IRQ_LLI_RD_DEC_ERR: LLI read decode error
 * @DWAXIDMAC_IRQ_LLI_WR_DEC_ERR: LLI write decode error
 * @DWAXIDMAC_IRQ_LLI_RD_SLV_ERR: LLI read slave error
 * @DWAXIDMAC_IRQ_LLI_WR_SLV_ERR: LLI write slave error
 * @DWAXIDMAC_IRQ_INVALID_ERR: LLI invalid error or Shadow register error
 * @DWAXIDMAC_IRQ_MULTIBLKTYPE_ERR: Slave Interface Multiblock type error
 * @DWAXIDMAC_IRQ_DEC_ERR: Slave Interface decode error
 * @DWAXIDMAC_IRQ_WR2RO_ERR: Slave Interface write to read only error
 * @DWAXIDMAC_IRQ_RD2RWO_ERR: Slave Interface read to write only error
 * @DWAXIDMAC_IRQ_WRONCHEN_ERR: Slave Interface write to channel error
 * @DWAXIDMAC_IRQ_SHADOWREG_ERR: Slave Interface shadow reg error
 * @DWAXIDMAC_IRQ_WRONHOLD_ERR: Slave Interface hold error
 * @DWAXIDMAC_IRQ_LOCK_CLEARED: Lock Cleared Status
 * @DWAXIDMAC_IRQ_SRC_SUSPENDED: Source Suspended Status
 * @DWAXIDMAC_IRQ_SUSPENDED: Channel Suspended Status
 * @DWAXIDMAC_IRQ_DISABLED: Channel Disabled Status
 * @DWAXIDMAC_IRQ_ABORTED: Channel Aborted Status
 * @DWAXIDMAC_IRQ_ALL_ERR: Bitmask of all error interrupts
 * @DWAXIDMAC_IRQ_ALL: Bitmask of all interrupts
 */
enum {
	DWAXIDMAC_IRQ_NONE		= 0,
	DWAXIDMAC_IRQ_BLOCK_TRF		= BIT(0),
	DWAXIDMAC_IRQ_DMA_TRF		= BIT(1),
	DWAXIDMAC_IRQ_SRC_TRAN		= BIT(3),
	DWAXIDMAC_IRQ_DST_TRAN		= BIT(4),
	DWAXIDMAC_IRQ_SRC_DEC_ERR	= BIT(5),
	DWAXIDMAC_IRQ_DST_DEC_ERR	= BIT(6),
	DWAXIDMAC_IRQ_SRC_SLV_ERR	= BIT(7),
	DWAXIDMAC_IRQ_DST_SLV_ERR	= BIT(8),
	DWAXIDMAC_IRQ_LLI_RD_DEC_ERR	= BIT(9),
	DWAXIDMAC_IRQ_LLI_WR_DEC_ERR	= BIT(10),
	DWAXIDMAC_IRQ_LLI_RD_SLV_ERR	= BIT(11),
	DWAXIDMAC_IRQ_LLI_WR_SLV_ERR	= BIT(12),
	DWAXIDMAC_IRQ_INVALID_ERR	= BIT(13),
	DWAXIDMAC_IRQ_MULTIBLKTYPE_ERR	= BIT(14),
	DWAXIDMAC_IRQ_DEC_ERR		= BIT(16),
	DWAXIDMAC_IRQ_WR2RO_ERR		= BIT(17),
	DWAXIDMAC_IRQ_RD2RWO_ERR	= BIT(18),
	DWAXIDMAC_IRQ_WRONCHEN_ERR	= BIT(19),
	DWAXIDMAC_IRQ_SHADOWREG_ERR	= BIT(20),
	DWAXIDMAC_IRQ_WRONHOLD_ERR	= BIT(21),
	DWAXIDMAC_IRQ_LOCK_CLEARED	= BIT(27),
	DWAXIDMAC_IRQ_SRC_SUSPENDED	= BIT(28),
	DWAXIDMAC_IRQ_SUSPENDED		= BIT(29),
	DWAXIDMAC_IRQ_DISABLED		= BIT(30),
	DWAXIDMAC_IRQ_ABORTED		= BIT(31),
	DWAXIDMAC_IRQ_ALL_ERR		= (GENMASK(21, 16) | GENMASK(14, 5)),
	DWAXIDMAC_IRQ_ALL		= GENMASK(31, 0)
};

enum {
	DWAXIDMAC_TRANS_WIDTH_8		= 0,
	DWAXIDMAC_TRANS_WIDTH_16,
	DWAXIDMAC_TRANS_WIDTH_32,
	DWAXIDMAC_TRANS_WIDTH_64,
	DWAXIDMAC_TRANS_WIDTH_128,
	DWAXIDMAC_TRANS_WIDTH_256,
	DWAXIDMAC_TRANS_WIDTH_512,
	DWAXIDMAC_TRANS_WIDTH_MAX	= DWAXIDMAC_TRANS_WIDTH_512
};

struct GB02STR39 *GB02FUNC224(struct GB02STR42 *dma_ctrl,
	size_t len);
void
gb02_dma_multi_blk_linklist_mode_start(struct GB02STR42 *dma_ctrl);
void GB02FUNC115(struct GB02STR42 *chip);
int GB02FUNC148(struct GB02STR42 *dma_ctrl,
	int data_bytes, int ch_id);
int GB02FUNC125(struct GB02STR42 *dma_ctrl,
	u64 addr, int chid);
void GB02FUNC132(struct GB02STR42 *dma_ctrl,
	int abytes, int chid);
void GB02FUNC100(struct GB02STR40 *chan, u32 irq_mask);
void GB02FUNC110(struct GB02STR40 *chan);
void GB02FUNC133(struct GB02STR42 *dma_ctrl);
#endif
