/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __PCIE_RESIZEBAR_H
#define __PCIE_RESIZEBAR_H

/* Resizable BARs */
#define  GB02MAC355		4	/* capability register */
#define  GB02MAC358		0x00FFFFF0  /* supported BAR sizes */
#define  GB02MAC361		8	/* control register */
#define  GB02MAC364		0x00000007  /* BAR index */
#define  GB02MAC367	0x000000E0  /* # of resizable BARs */
#define  GB02MAC370	5	    /* shift for # of BARs */
#define  GB02MAC373	0x00001F00  /* BAR size */
#define  GB02MAC376	8	    /* shift for BAR size */

#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 19, 0)
struct gb_pci_dev_resource {
	struct list_head list;
	struct resource *res;
	struct pci_dev *dev;
	resource_size_t start;
	resource_size_t end;      
	resource_size_t add_size;
	resource_size_t min_align;
	unsigned long flags;
};
void gb_pci_restore_rebar_state(struct pci_dev *pdev);
#endif

void GB02FUNC181(struct pci_dev *pdev);
#endif