#!/bin/bash

OS_ID=`. /etc/os-release && echo $ID`
OS_VERSION_ID=`. /etc/os-release && echo $VERSION_ID`
OS_NAME=$OS_ID$OS_VERSION_ID
KERNEL_VERSION=`uname -r`
GENBU_CONF="/etc/modules-load.d/genbu.conf"
GENBU_SERVICE_NAME="genbu.service"
GENBU_SERVICE_PATH="/lib/systemd/system/"
#CHECK_KYLIN=`grep -q "kylin" /etc/os-release && echo "true" || true`
CHECK_ARCH=`arch`

function uninstall_gb_config() {
if [ "$OS_NAME" == "kylinv4" ]; then
    if [ -e /lib/udev/rules.d/91-pulseaudio-custom.rules  ];then
        rm /lib/udev/rules.d/91-pulseaudio-custom.rules
    fi
    if [ -e /etc/udev/rules.d/99-z_hdmi_sound.rules  ];then
        rm /etc/udev/rules.d/99-z_hdmi_sound.rules
    fi

else
    if [ -e /usr/lib/udev/rules.d/91-pulseaudio-custom.rules ];then
        rm /usr/lib/udev/rules.d/91-pulseaudio-custom.rules
    fi

    if [ -e /usr/local/genbu/rules/91-pulseaudio-custom.rules ];then
        rm /usr/local/genbu/rules/91-pulseaudio-custom.rules
    fi
fi
    
    if [ -e /usr/share/pulseaudio/alsa-mixer/profile-sets/gb_audio.conf ];then
        rm /usr/share/pulseaudio/alsa-mixer/profile-sets/gb_audio.conf
    fi
}
if [ -e $GENBU_CONF ];then
    rm -f $GENBU_CONF
fi
if [ -e $GENBU_SERVICE_PATH$GENBU_SERVICE_NAME ];then
    systemctl disable -q $GENBU_SERVICE_NAME
fi

#if [ "$1" = "remove" ] || [ "$1" = "upgrade" ]; then
#    sudo dkms remove -m gb02 -v 1.1.600-2 --all || true
#fi


sed -i '/genbu02\/gb02.ko/d' /lib/modules/$KERNEL_VERSION/modules.dep
sed -i '/genbu02\/gb02.ko/d' /lib/modules/$KERNEL_VERSION/modules.order


if grep -q "kylin" /etc/os-release; then
    . /etc/default/grub
    GRUB_DEFAULT=`echo $GRUB_CMDLINE_LINUX_DEFAULT | sed 's/video=efifb:on//g'`
    sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/s/=.*/=\"${GRUB_DEFAULT}\"/" /etc/default/grub
    if test "$CHECK_ARCH" == "aarch64"; then
        update-grub-ftefi
    fi
    sed -i '/^gb02$/d; /^gb02\s/d; /^gb02\t/d' /etc/initramfs-tools/modules
    echo "KYLIN uninstall update-initramfs......"
    update-initramfs -u -k $KERNEL_VERSION >/dev/null 2>&1
else
    CHECK_UOS="uos"
    UOS_VER="/etc/os-release"
    if [ -e $UOS_VER ];then
	set +e
        result=$(cat $UOS_VER|grep $CHECK_UOS)
	set -e
        if test -n "$result"; then
            sed -i '/^gb02$/d; /^gb02\s/d; /^gb02\t/d' /etc/initramfs-tools/modules
            echo "update-initramfs......"
            update-initramfs -u -k $KERNEL_VERSION >/dev/null 2>&1
        fi
    fi
fi

uninstall_gb_config
