
#ifndef __GB02_DP_H__
#define __GB02_DP_H__

#include <linux/types.h>
#include "gb_dp_dptx.h"
#if LINUX_VERSION_CODE < KERNEL_VERSION(6, 6, 0)
#include <drm/drm_dp_helper.h>
#else
#include <drm/display/drm_dp.h>
#endif

#define GB02MAC1509  0x00000
#define GB02MAC1511  0x10000
#define GB02MAC1512   0x20000
#define GB02MAC1513  0x30000
#define GB02MAC1515   0x40000
#define GB02MAC1517  0x50000
#define GB02MAC1519   0x60000

#define GB02MAC1521              (0x0<<28)
#define GB02MAC1523             (0x1<<28)
#define GB02MAC1525       (0x2<<28)
#define GB02MAC1527              (0x4<<28)
#define GB02MAC1528              (0x5<<28)
#define GB02MAC1530   (0x6<<28)
#define GB02MAC1532           (0x8<<28)
#define GB02MAC1534           (0x9<<28)
#define GB02MAC1536		28

#define GB02MAC1538			0x0
#define GB02MAC1540			0x1

#define GB02MAC1541	0x040A
#define GB02MAC1543	0x040B
#define GB02MAC1545		0x1
#define GB02MAC1547		0x2

#ifndef fallthrough
#define fallthrough do {} while (0)
#endif

typedef union {
	uint32_t val;
	struct {
		uint32_t en:1;
		uint32_t bypass:1;
		uint32_t dsmen:1;
		uint32_t refdiv:6;
		uint32_t postdiv2:3;
		uint32_t postdiv1:3;
		uint32_t fbdiv:12;
		uint32_t extdiv:4;
		uint32_t extdiven:1;
	} data;
} tDCDP_PLLP_CFG0;

typedef union {
	uint32_t val;
	struct {
		uint32_t frac:24;
		uint32_t update:1;
		uint32_t rsvd:7;
	} data;
} tDCDP_PLLP_CFG1;

typedef union {
	uint32_t val;
	struct {
		uint32_t en:1;
		uint32_t bypass:1;
		uint32_t dsmen:1;
		uint32_t refdiv:6;
		uint32_t postdiv2:3;
		uint32_t postdiv1:3;
		uint32_t fbdiv:12;
		uint32_t rsvd:5;
	} data;
} tDCDP_PLLM_CFG0;

typedef union {
	uint32_t val;
	struct {
		uint32_t frac:24;
		uint32_t update:1;
		uint32_t rsvd:7;
	} data;
} tDCDP_PLLM_CFG1;

typedef union {
	uint32_t val;
	struct {
		uint32_t en:1;
		uint32_t bypass:1;
		uint32_t refdiv:6;
		uint32_t postdiv2:3;
		uint32_t postdiv1:3;
		uint32_t fbdiv:12;
		uint32_t pllbw:1;
		uint32_t rsvd:5;
	} data;
} tDCDP_PLLD_CFG0;

typedef union {
	uint32_t val;
	struct {
		uint32_t frac:24;
		uint32_t update:1;
		uint32_t rsvd:7;
	} data;
} tDCDP_PLLD_CFG1;

typedef union {
	uint32_t val;
	struct {
		uint32_t plld_locked:1;
		uint32_t pllm_locked:1;
		uint32_t pllp_locked:1;
		uint32_t rsvd:29;
	} data;
} tDCDP_PLL_STAT;

enum DPTX_AUDIO_STATUS {
	DPTX_AUDIO_START_PLAY = 0,
	DPTX_AUDIO_EDID_CONFIGURE,
	DPTX_AUDIO_MAX_VAL,
};

extern int GB02FUNC970(const struct drm_display_mode *mode,
	int dp_index);
extern bool GB02FUNC1490(int dp_index);
extern int GB02FUNC988(int dp_index,
	struct drm_device *drm);
extern int GB02FUNC853(int dp_index);
extern int GB02FUNC860(int dp_index);
extern void GB02FUNC1494(struct work_struct *work);
extern int GB02FUNC979(struct dptx *dptx_info);
extern unsigned char *GB02FUNC1493(int dp_index);
extern bool GB02FUNC1491(int dp_index);
extern ssize_t GB02FUNC1018(struct drm_dp_aux *aux,
                                  struct drm_dp_aux_msg *msg);
void GB02FUNC992(struct dptx *dptx_info);
int GB02FUNC1426(struct dptx *dptx, int set_info);
int GB02FUNC1023(struct GB02STR70 *gb_pcie);

#endif
