// SPDX-License-Identifier: GPL-2.0-only
/*
 */

#include <linux/module.h>
#include "gb_governor.h"

static int GB02FUNC632(struct gb_devfreq *df,
				    unsigned long *freq)
{
	/*
	 * target callback should be able to get floor value as
	 * said in devfreq.h
	 */
	*freq = GB02MAC1062;
	return 0;
}

static int GB02FUNC635(struct gb_devfreq *devfreq,
				unsigned int event, void *data)
{
	int ret = 0;

	if (event == GB02MAC1056) {
		mutex_lock(&devfreq->lock);
		ret = GB02FUNC481(devfreq);
		mutex_unlock(&devfreq->lock);
	}

	return ret;
}

struct gb_devfreq_governor devfreq_performance = {
	.name = GB_DEVFREQ_GOV_PERFORMANCE,
	.get_target_freq = GB02FUNC632,
	.event_handler = GB02FUNC635,
};


