/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __PCIE_MSG_H
#define __PCIE_MSG_H
#include "gb_device.h"

#define GB02MAC1345 (1024 * 1024 - 4 * 4) 

#define GB02MAC1025 'U'
#define UPGRADE_MCU_CMD_START _IOW(GB02MAC1025, 1u, int)
#define UPGRADE_MCU_CMD_GET_PROGRESS _IOW(GB02MAC1025, 2u, int)
#define UPGRADE_MCU_CMD_SET_IMAGE_INFO _IOW(GB02MAC1025, 3u, int)

#define GB02MAC1346  0x57140001
#define GB02MAC1347   0x5714FFF0
#define GB02MAC1348   0x1001
#define GB02MAC1349      0x1002

#define GB02MAC1350 (0x1000000 + 0x40000)

struct GB02STR145 {
	struct device *dev;
	struct GB02STR38 *gbdev;
};

typedef struct
{
	uint32_t magic;
	uint32_t cmd;
	uint32_t len;
	char * data;

}pcie_msg_t;

enum pcie_msg_cmd_e
{
	PCIE_DDR_TEST,
	PCIE_DDR_READ,
	PCIE_DDR_WRITE,
	PCIE_ECC_SET,
	PCIE_ECC_GET,
};

typedef struct
{
	char * cmd_str;
	pcie_msg_t pcie_msg;

}pcie_cmd_t;

int GB02FUNC1128(struct GB02STR38 *gbdev);
void GB02FUNC1133(struct GB02STR38 *gbdev);
u64 GB02FUNC1118(void);
#endif
