/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __GB02_PVT__
#define __GB02_PVT__
#include "gb-peripherals-common.h"

#ifndef BIT
#define BIT(x) (1 << (x))
#endif

#define GB02MAC1631 0x82400000
#define GB02MAC1633 0x80000000

#define GB02MAC1636 GB02MAC691
#define GB02MAC1639 GB02MAC1052 // 0x82400000

/* 75 25 typical conditions steady DOUT values */
#define DOUT75std 2874LL
#define DOUT25std 2761LL

/* assumes 75 and 25 degrees actual conditions DOUT values, for now*/
#define DOUT75act 2902LL
#define DOUT25act 2784LL

#define DOUTstd 2067
#define Vref 1170 // mV
#define GB02MAC1649 3000
#define GB02MAC1652 2000
#define D1 ((3 * DOUT75act - DOUT25act) / 2)
#define D2 ((DOUT75act + DOUT25act) / 2)
#define D3 ((3 * DOUT25act - DOUT75act) / 2)
#define D4 (DOUT25act - (DOUT75act - DOUT25act) * 9 / 10)

#define GB02MAC1656 (0x00)

#define GB02MAC1660 20
#define GB02MAC1662(x) (((x)&0x7ff) << GB02MAC1660) // default 3000
#define GB02MAC1664 8
#define GB02MAC1665(x) (((x)&0x7ff) << GB02MAC1664) // default 2500
#define GB02MAC1668 BIT(7)															 // 1: power up  0:power down --default 1
#define GB02MAC1671 1
#define GB02MAC1673 0
#define PVT_RESETn_MASK BIT(6) // low active ,default 0
#define GB02MAC1677 0
#define GB02MAC1680 1

#define GB02MAC1683 BIT(5) // 1:temperature 0 :voltage default 1
#define GB02MAC1686 1
#define GB02MAC1688 0
#define TEST_EN_MASK BIT(4)		   // IP test enable signal ,defaul 0
#define BAND_GAP_TRIM(x) ((x)&0x7) // bandgap trim signal ,default 4'b0111

#define GB02MAC1693 (0x04)

#define GB02MAC1696 12
#define GB02MAC1699(x) (((x)&0x7ff) << GB02MAC1696) // default 3000
#define GB02MAC1702 0
#define GB02MAC1705(x) (((x)&0x7ff) << GB02MAC1702) // default 2500

#define GB02MAC1709 (0x08)
#define GB02MAC1712 12
#define GB02MAC1715(x) (((x)&0x7ff) << GB02MAC1712) // default 3000
#define GB02MAC1717 0
#define GB02MAC1719(x) (((x)&0x7ff) << GB02MAC1717) // default 2500

#define GB02MAC1722 (0x0C)

#define GB02MAC1724 24
#define GB02MAC1726(x) (((x)&0xff) << GB02MAC1724) // default 8'd31

#define GB02MAC1729 12
#define GB02MAC1731(x) (((x)&0x7ff) << GB02MAC1729) // default 3000
#define GB02MAC1732 0
#define GB02MAC1733(x) (((x)&0x7ff) << GB02MAC1732) // default 2500

#define GB02MAC1736 (0x10)
#define GB02MAC1738 BIT(3) // write 1 clear default 0
#define GB02MAC1740 BIT(2)	 // write 1 clear default 0
#define GB02MAC1742 BIT(1) // write 1 clear default 0
#define GB02MAC1744 BIT(0)	 // write 1 clear default 0

#define GB02MAC1746 (0x14)

#define GB02MAC1749 BIT(19)
#define GB02MAC1751 BIT(18)
#define GB02MAC1754 BIT(17)
#define GB02MAC1756 BIT(16)
#define GB02MAC1757 BIT(15)
#define GB02MAC1759 BIT(14)
#define GB02MAC1761 BIT(13)
#define GB02MAC1763 BIT(12)
#define DOUT(x) ((x)&0xfff)

#ifdef CONFIG_MCU_PVT
int GB02FUNC1186(struct GB02STR38 *gb_dev, struct GB02STR72 *peri_info);
void GB02FUNC1188(struct GB02STR72 *peri_info);
int GB02FUNC1164(void);
#else
static inline int GB02FUNC1186(struct GB02STR38 *gb_dev, struct GB02STR72 *peri_info)
{
	return 0;
}
static inline void GB02FUNC1188(struct GB02STR72 *peri_info)
{
	return;
}
static inline int GB02FUNC1164(void)
{
	return 0;
}
#endif
#endif
